﻿using Infragistics.Win.UltraWinDataSource;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WG_LoadOnDemand
{
    public partial class Form1 : Form
    {
        Random random = new Random(); 

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = this.ultraDataSource1;


            // Add three columns to the root band. 
            this.ultraDataSource1.Band.Columns.Add("ID", typeof(int));
            this.ultraDataSource1.Band.Columns.Add("Col0", typeof(int));
            this.ultraDataSource1.Band.Columns.Add("Col1", typeof(string));

            // Set the count on the root rows collection to 100. 
            this.ultraDataSource1.Rows.SetCount(1000);

            // Set the id on the root rows. 
            UltraDataColumn column = this.ultraDataSource1.Band.Columns["ID"];
            for (int i = 0; i < this.ultraDataSource1.Rows.Count; i++)
                this.ultraDataSource1.Rows[i][column] = i; 

        }

        private void ultraDataSource1_CellDataRequested(object sender, CellDataRequestedEventArgs e)
        {
            UltraDataRow row = e.Row;

            
            switch (e.Column.Key)
            {
                case "Col0":
                    e.Data = this.random.Next();
                    break;
                case "Col1":
                    e.Data = "String " + this.random.Next();
                    break;
            }

            e.CacheData = true; 

        }

    }
}
